/****************************************************************************
  FILE: JEx31.java, TomaszMajor-02Feb99
  PURPOSE: Tango tutorial example
****************************************************************************/


import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import webwisdom.tango.*;


public class JEx22 extends Applet implements ActionListener
{
    private static final String CL="JEx22";


    Button button;
    TAgent agent=null;


    public JEx22()
    {
      button=new Button("debug");
      setLayout(new BorderLayout());
      add("North",button);
      button.addActionListener(this);
    }// JEx ________________________________________________________________


    public void init()
    {
      try
      {
	agent=new TAgent(new TLAgentApplet(this));
	//agent=new TAgent(new TLAgentFake("kopernik",32831));
	agent.addTDataListener(this);
	text.setText(agent.getUserName());
      }
      catch(TangoException e)
      {
	e.printStackTrace();
      }
    }// init _______________________________________________________________


    public void destroy()
    {
      if(agent!=null)
	agent.exit();
    }// destroy ____________________________________________________________


    public void actionPerformed(ActionEvent evt)
    {
      if(evt.getSource()==text)
      {
	if(agent!=null)
	  agent.send((text.getText()).getBytes());
      }
      else if(evt.getSource()==button)
      {
	if(agent!=null)
	{
	  System.out.println(CL+".actionPerformed(): agent="+agent);
	  System.out.println("\tuserName="+agent.getUserName());
	  System.out.println("\tmasterName="+agent.getMasterName());
	  System.out.println("\tisMaster="+agent.isMaster());
	  System.out.println("\tparticipantNames="+arrayToString(agent.getParticipantNames()));
	  System.out.println("\tisAudioAvailable="+agent.isAudioAvailable());
	}
      }
    }// actionPerformed ____________________________________________________


    public void receive(byte b[])
    {
      text.setText(new String(b));
    }// receive ____________________________________________________________


    private static String arrayToString(Object[] ss)
    {
      StringBuffer s=new StringBuffer();
      s.append("{");
      for(int i=0;i<ss.length;i++)
      {
	s.append(ss[i].toString());
	if(i<(ss.length-1))
	  s.append(",");
      }
      s.append("}");
      return s.toString();
    }// arrayToString ______________________________________________________


}// JEx ////////////////////////////////////////////////////////////////////


